Add SUSE support

Add support for SUSE based distributions. Since we grab some packages
from the OBS repositories, we need to use the 'force' option to allow
zypper switch vendor on these packages. We also update the bindep.txt,
run_tests.sh, tests-repo-clone.sh and Vagrantfile files from the
openstack-ansible-tests repository.

Change-Id: Icea249aae20156b253017c6028f0ba2bb74bd577
This commit is contained in:
Markos Chandras 2017-04-10 14:23:54 +01:00
parent abf24e4bf0
commit a0ca13626a
7 changed files with 145 additions and 73 deletions

25
Vagrantfile vendored
View File

@ -3,9 +3,24 @@ Vagrant.configure(2) do |config|
v.memory = 2048
v.cpus = 2
end
config.vm.box = "ubuntu/xenial64"
config.vm.provision "shell", inline: <<-SHELL
cd /vagrant
./run_tests.sh
SHELL
config.vm.provision "shell",
privileged: false,
inline: <<-SHELL
cd /vagrant
./run_tests.sh
SHELL
config.vm.define "ubuntu1604" do |xenial|
xenial.vm.box = "ubuntu/xenial64"
end
config.vm.define "opensuse422" do |leap422|
leap422.vm.box = "opensuse/openSUSE-42.2-x86_64"
end
config.vm.define "centos7" do |centos7|
centos7.vm.box = "centos/7"
end
end

View File

@ -3,12 +3,24 @@
#
# See the following for details:
# - http://docs.openstack.org/infra/bindep/
# - https://github.com/openstack-infra/bindep
# - https://git.openstack.org/cgit/openstack-infra/bindep
#
# Even if the role does not make use of this facility, it
# is better to have this file empty, otherwise OpenStack-CI
# will fall back to installing its default packages which
# will potentially be detrimental to the tests executed.
#
# Note:
# This file is maintained in the openstack-ansible-tests repository.
# https://git.openstack.org/cgit/openstack/openstack-ansible-tests/tree/bindep.txt
# If you need to remove or add extra dependencies, you should modify
# the central file instead and once your change is accepted then update
# this file as well. The purpose of this file is to ensure that Python and
# Ansible have all their necessary binary requirements on the test host before
# tox executes. Any binary requirements needed by services/roles should be
# installed by those roles in their applicable package install tasks, not through
# using this file.
#
# Base requirements for Ubuntu
build-essential [platform:dpkg]
@ -18,24 +30,27 @@ libffi-dev [platform:dpkg]
python2.7 [platform:dpkg]
python-dev [platform:dpkg]
# Base requirements for CentOS
# Base requirements for RPM distros
gcc [platform:rpm]
gcc-c++ [platform:rpm]
git [platform:rpm]
python-devel [platform:rpm]
libffi-devel [platform:rpm]
openssl-devel [platform:rpm]
python-devel [platform:rpm]
# For SELinux
libselinux-python [platform:rpm]
libselinux-python [platform:redhat]
libsemanage-python [platform:redhat]
# For SSL SNI support
python-pyasn1 [platform:dpkg]
python-openssl [platform:dpkg]
python-pyasn1 [platform:dpkg platform:suse]
python-openssl [platform:dpkg platform:suse]
python-ndg-httpsclient [platform:ubuntu]
python2-pyasn1 [platform:rpm]
python2-pyOpenSSL [platform:rpm]
python-ndg_httpsclient [platform:rpm]
python2-pyasn1 [platform:redhat]
python2-pyOpenSSL [platform:redhat]
python-pyOpenSSL [platform:suse]
python-ndg_httpsclient [platform:redhat]
python-ndg-httpsclient [platform:suse]
# Required for compressing collected log files in CI
gzip

View File

@ -26,6 +26,11 @@ galaxy_info:
- name: EL
versions:
- 7
- name: opensuse
versions:
- 42.1
- 42.2
- 42.3
categories:
- cloud
- python

View File

@ -12,63 +12,44 @@
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Note:
# This file is maintained in the openstack-ansible-tests repository.
# https://git.openstack.org/cgit/openstack/openstack-ansible-tests/tree/run_tests.sh
# If you need to modify this file, update the one in the openstack-ansible-tests
# repository and then update this file as well. The purpose of this file is to
# prepare the host and then execute all the tox tests.
#
set -xeuo pipefail
set -xeu
FUNCTIONAL_TEST=${FUNCTIONAL_TEST:-true}
source /etc/os-release || source /usr/lib/os-release
# Install python2 for Ubuntu 16.04 and CentOS 7
if which apt-get; then
sudo apt-get update && sudo apt-get install -y python
fi
install_pkg_deps() {
pkg_deps="git"
if which yum; then
sudo yum install -y python
fi
case ${ID,,} in
*suse*) pkg_mgr_cmd="zypper -n in" ;;
centos|rhel) pkg_mgr_cmd="yum install -y" ;;
fedora) pkg_mgr_cmd="dnf -y install" ;;
ubuntu|debian) pkg_mgr_cmd="apt-get install -y" ;;
*) echo "unsupported distribution: ${ID,,}"; exit 1 ;;
esac
# Install pip.
if ! which pip; then
curl --silent --show-error --retry 5 \
https://bootstrap.pypa.io/get-pip.py | sudo python2.7
fi
eval sudo $pkg_mgr_cmd $pkg_deps
}
# Install bindep and tox with pip.
sudo pip install bindep tox
# CentOS 7 requires two additional packages:
# redhat-lsb-core - for bindep profile support
# epel-release - required to install python-ndg_httpsclient/python2-pyasn1
if which yum; then
sudo yum -y install redhat-lsb-core epel-release
fi
# Get a list of packages to install with bindep. If packages need to be
# installed, bindep exits with an exit code of 1.
BINDEP_PKGS=$(bindep -b -f bindep.txt test || true)
echo "Packages to install: ${BINDEP_PKGS}"
# Install a list of OS packages provided by bindep.
if which apt-get; then
sudo apt-get update
DEBIAN_FRONTEND=noninteractive \
sudo apt-get -q --option "Dpkg::Options::=--force-confold" \
--assume-yes install $BINDEP_PKGS
elif which yum; then
# Don't run yum with an empty list of packages.
# It will fail and cause the script to exit with an error.
if [[ ${#BINDEP_PKGS} > 0 ]]; then
sudo yum install -y $BINDEP_PKGS
git_clone_repo() {
if [[ ! -d tests/common ]]; then
git clone https://git.openstack.org/openstack/openstack-ansible-tests tests/common
fi
fi
}
# Loop through each tox environment and run tests.
for tox_env in $(awk -F= '/envlist/ { gsub(",", " "); print $2 }' tox.ini); do
echo "Executing tox environment: ${tox_env}"
if [[ ${tox_env} == ansible-functional ]]; then
if ${FUNCTIONAL_TEST}; then
tox -e ${tox_env}
fi
else
tox -e ${tox_env}
fi
done
install_pkg_deps
git_clone_repo
# start executing the main test script
source tests/common/run_tests_common.sh
# vim: set ts=4 sw=4 expandtab:

View File

@ -17,7 +17,10 @@
package:
name: "{{ repo_build_distro_packages }}"
state: "{{ repo_build_package_state }}"
update_cache: "{{ (ansible_pkg_mgr == 'apt') | ternary('yes', omit) }}"
# We switch vendors in a few SUSE packages so we need to force the
# installation
force: "{{ (ansible_pkg_mgr == 'zypper' ) | ternary('yes', omit) }}"
update_cache: "{{ (ansible_pkg_mgr == 'apt' or ansible_pkg_mgr == 'zypper') | ternary('yes', omit) }}"
cache_valid_time: "{{ (ansible_pkg_mgr == 'apt') | ternary(cache_timeout, omit) }}"
register: install_packages
until: install_packages | success
@ -26,3 +29,4 @@
tags:
- repo-build-apt-packages
- repo-build-yum-packages
- repo-build-zypper-packages

View File

@ -34,28 +34,39 @@ export TESTING_HOME=${TESTING_HOME:-$HOME}
export WORKING_DIR=${WORKING_DIR:-$(pwd)}
export CLONE_UPGRADE_TESTS=${CLONE_UPGRADE_TESTS:-no}
## Main ----------------------------------------------------------------------
## Functions -----------------------------------------------------------------
function create_tests_clonemap {
# Prepare the clonemap for zuul-cloner to use
# This is placed here instead of inside the conditional
# to prevent indentation problems.
cat > ${TESTING_HOME}/tests-clonemap.yaml << EOF
clonemap:
- name: openstack/openstack-ansible-tests
dest: ${WORKING_DIR}/tests/common
EOF
}
## Main ----------------------------------------------------------------------
# If zuul-cloner is present, use it so that we
# also include any dependent patches from the
# tests repo noted in the commit message.
if [[ -x /usr/zuul-env/bin/zuul-cloner ]]; then
# Prepare the clonemap for zuul-cloner to use
create_tests_clonemap
# Execute the clone
/usr/zuul-env/bin/zuul-cloner \
--cache-dir /opt/git \
--map ${TESTING_HOME}/tests-clonemap.yaml \
git://git.openstack.org \
openstack/openstack-ansible-tests
# Clean up the clonemap.
rm -f ${TESTING_HOME}/tests-clonemap.yaml
# Alternatively, use a simple git-clone. We do
# not re-clone if the directory exists already
# to prevent overwriting any local changes which
@ -73,9 +84,6 @@ elif [[ ! -d tests/common ]]; then
fi
fi
# Clean up the clonemap.
rm -f ${TESTING_HOME}/tests-clonemap.yaml
# If this test set includes an upgrade test, the
# previous stable release tests repo must also be
# cloned.

44
vars/suse-42.yml Normal file
View File

@ -0,0 +1,44 @@
---
# Copyright 2016, @WalmartLabs
# Copyright 2017, SUSE LINUX GmbH.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
repo_build_distro_packages:
- patterns-openSUSE-devel_basis
- cmake
- git-core
- krb5-devel # required to build pykerberos
- liberasurecode-devel # required to build pyeclib
- libffi-devel # required to build xattr
- libjpeg8-devel # required to build pillow
- libvirt-devel # required to build libvirt-python
- libxslt1
- libxslt-devel # required to build lxml
- lxc-devel # required to build lxc-python2
- libmysqlclient-devel # required to build MySQL-python
- cyrus-sasl-devel # required to build python-ldap
- openldap2-devel # required to build python-ldap
- postgresql-devel # required to build psycopg2
- python-devel
- libopenssl-devel # required to build cryptography
- sqlite2-devel # required to build pysqlite
- swig
- which
- tar # required for /opt/op-venv-script.sh
# workaround for https://github.com/pypa/virtualenv/issues/565
repo_build_venv_command_options: >
{{ virtualenv_bin }}
--extra-search-dir {{ repo_build_release_path }}
--never-download